program Random;

uses
  Classes,
  Forms,
  RandomDlgs in 'RandomDlgs.pas' {RandomSetForm},
  Registry,
  Exes,
  SysUtils,
  Windows,
  hrDlgs in 'hrDlgs.pas' {HorribleRevengeForm},
  Tools;

{$R *.RES}

var
  s, s2: String; { external ??? }
  Registry: TAppRegistry;
  i, ii: integer;
  PlayList: TStrings;
  pi: tProcessInformation;
  si: tStartupInfo;
  ScrnType: longint;
  Wanted: array[0.._MAX_PATH] of char;
  Result: HKEY;

begin
  Application.Initialize;
  Application.Title := 'Randomizing Screensavers';
  StdLog( #13#10'***************************************************************' );
  StdLog( sApplicationName );
  StdLog( 'ParamStr(1): ' + ParamStr( 1 ) );
  Wanted[0] := #0;

  if ParamCount = 1 then
  begin
    s := ParamStr(1);
    if s[1] = '/' then
    begin
      Randomize;
      case UpCase(s[2]) of
      'S': begin
             Registry := TAppRegistry.Create( Application );
             PlayList := TStringList.Create;
             try
               with Registry do
               begin
                 CompanyName     := sCompanyName;
                 ApplicationName := sApplicationName;
                 GroupName       := sRandomGroup;
                 GetItems;

                 if Values.Count = 0 then
                 begin
                   StdLog( 'Random called without a screen saver defined.' );
                   Application.CreateForm(THorribleRevengeForm, HorribleRevengeForm);
  end else
                 begin
                   repeat
                     if #0 <> Wanted[0] then
                     begin
                       RegOpenKey( HKEY_CURRENT_USER, 'Software\' + sCompanyName + '\' + sApplicationName, Result );
                       RegDeleteKey( Result, 'wanted' );
                       RegCloseKey( Result );
                       Wanted[0] := #0;
                       StdLog( 'File not found: "' + s + '".' );
                     end else
                     begin
                       RegOpenKey( HKEY_CURRENT_USER, 'Software\' + sCompanyName + '\' + sApplicationName, Result );
                       i := _MAX_PATH;
                       RegQueryValueEx( Result, 'wanted', NIL, @ScrnType, @Wanted, @i );
                       RegCloseKey( Result );
                     end;

                     if #0 <> Wanted[0] then
                     begin
                       s := StrPas( Wanted );
                       StdLog( 'Found xlock parameter: "' + s + '".' );
                     end else
                     begin
                       for i := 0 to Values.Count - 1 do
                       begin
                         Str( i, s2 );
                         PlayList.Insert( i, Values[Data.IndexOf( s2 )] );
                       end;

                       ii := Trunc( ( Values.Count / 3 ) * SYSTEM.Random );
                       ii := ii + Trunc( ( Values.Count * 2 ) / 3 );
                       s := Values[0];
                       PlayList.Delete( 0 );
                       PlayList.Insert( ii, s );
                       s2 := PlayList[PlayList.Count-1];
                       PlayList.Delete( PlayList.Count-1 );
                       PlayList.Insert( Trunc( ( Values.Count * 2 ) / 3 ), s2 );

                       Values.Clear;
                       Data.Clear;
                       Values.Assign( PlayList );

                       for i := 0 to PlayList.Count - 1 do
                       begin
                         Str( i, s2 );
                         Data.Add( s2 );
                       end;
                       SetItems;

                       RegOpenKey( HKEY_CURRENT_USER, 'Software\' + sCompanyName + '\' + sApplicationName, Result );
                       StrPCopy( Wanted, s );
                       RegSetValueEx( Result, 'wanted', 0, REG_SZ, @Wanted, StrLen( Wanted ) );
                       RegCloseKey( Result );
                     end;
                     
                     GroupName := sGroupName;
                     GetItems;
                     i := Values.IndexOf( s );
                     s := Data[i];
                   until FileExists( s );

                   FillChar( si, sizeof( si ), 0 );
                   si.cb := sizeof( tStartupInfo );
                   GetStartupInfo( si );
                   with si do
                   begin
                     wShowWindow := wShowWindow or SW_SHOWMAXIMIZED;
                     dwFlags := dwFlags or STARTF_USESHOWWINDOW;
                     lpTitle := nil;
                     lpReserved := nil;
                   end;
                   s2 := ' ' + ParamStr(1);

                   if False = CreateProcess( nil, PChar( s + s2 ), nil, nil, FALSE,
                                            CREATE_SEPARATE_WOW_VDM or NORMAL_PRIORITY_CLASS, nil, nil, si, pi ) then
                   begin
                     i := GetLastError;
                     Str( i, s2 );
                     StdLog( 'Error calling "'+s+'": '+s2 );
                   end else
                   begin
                     StdLog( 'Calling Screensaver ' + s + ' ' + s2 );
                     WaitForInputIdle( pi.hProcess, INFINITE );
                     WaitForSingleObject( pi.hProcess, INFINITE );
                   end;
                 end;
               end;

               RegOpenKey( HKEY_CURRENT_USER, 'Software\' + sCompanyName + '\' + sApplicationName, Result );
               RegDeleteValue( Result, pChar( 'wanted' ) );
               RegCloseKey( Result );
             finally
               if Registry <> nil then
                 Registry.Free;
             end;
           end;
      'C': begin
             Application.CreateForm(TRandomSetForm, RandomSetForm);
           end;
    end;
  end;

  if ParamCount = 0 then
    Application.CreateForm( TRandomSetForm, RandomSetForm );
  Application.Run;
end;

end.
